﻿#region license
// boo - an extensible programming language for the CLI
// Copyright (C) 2004 Rodrigo Barreto de Oliveira
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
// 
// Contact Information
//
// mailto:rbo@acm.org
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by
// astgenerator.boo on 6/7/2004 23:57:03
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class BinaryExpressionImpl : Expression
	{

		protected BinaryOperatorType _operator;
		protected Expression _left;
		protected Expression _right;

		protected BinaryExpressionImpl()
		{
			InitializeFields();
		}
		
		protected BinaryExpressionImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		

		protected BinaryExpressionImpl(BinaryOperatorType operator_, Expression left, Expression right)
		{
			InitializeFields();
			Operator = operator_;
			Left = left;
			Right = right;
		}
			
		protected BinaryExpressionImpl(LexicalInfo lexicalInfo, BinaryOperatorType operator_, Expression left, Expression right) : base(lexicalInfo)
		{
			InitializeFields();
			Operator = operator_;
			Left = left;
			Right = right;
		}
			
		new public BinaryExpression CloneNode()
		{
			return Clone() as BinaryExpression;
		}

		override public NodeType NodeType
		{
			get
			{
				return NodeType.BinaryExpression;
			}
		}

		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}

			if (_left == existing)
			{
				this.Left = (Expression)newNode;
				return true;
			}

			if (_right == existing)
			{
				this.Right = (Expression)newNode;
				return true;
			}

			return false;
		}

		override public object Clone()
		{
			BinaryExpression clone = FormatterServices.GetUninitializedObject(typeof(BinaryExpression)) as BinaryExpression;
			clone._lexicalInfo = _lexicalInfo;
			clone._documentation = _documentation;
			clone._entity = _entity;
			

			clone._expressionType = _expressionType;
			

			clone._operator = _operator;

			if (null != _left)
			{
				clone._left = _left.Clone() as Expression;
				clone._left.InitializeParent(clone);
			}

			if (null != _right)
			{
				clone._right = _right.Clone() as Expression;
				clone._right.InitializeParent(clone);
			}
			
			return clone;
		}
			
		public BinaryOperatorType Operator
		{
			get
			{
				return _operator;
			}
			

			set
			{
				_operator = value;
			}

		}
		

		public Expression Left
		{
			get
			{
				return _left;
			}
			

			set
			{
				if (_left != value)
				{
					_left = value;
					if (null != _left)
					{
						_left.InitializeParent(this);

					}
				}
			}
			

		}
		

		public Expression Right
		{
			get
			{
				return _right;
			}
			

			set
			{
				if (_right != value)
				{
					_right = value;
					if (null != _right)
					{
						_right.InitializeParent(this);

					}
				}
			}
			

		}
		

		private void InitializeFields()
		{

		}
	}
}
