﻿#region license
// boo - an extensible programming language for the CLI
// Copyright (C) 2004 Rodrigo Barreto de Oliveira
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
// 
// Contact Information
//
// mailto:rbo@acm.org
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by
// astgenerator.boo on 6/7/2004 23:57:02
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class DeclarationStatementImpl : Statement
	{

		protected Declaration _declaration;
		protected Expression _initializer;

		protected DeclarationStatementImpl()
		{
			InitializeFields();
		}
		
		protected DeclarationStatementImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		

		protected DeclarationStatementImpl(Declaration declaration, Expression initializer)
		{
			InitializeFields();
			Declaration = declaration;
			Initializer = initializer;
		}
			
		protected DeclarationStatementImpl(LexicalInfo lexicalInfo, Declaration declaration, Expression initializer) : base(lexicalInfo)
		{
			InitializeFields();
			Declaration = declaration;
			Initializer = initializer;
		}
			
		new public DeclarationStatement CloneNode()
		{
			return Clone() as DeclarationStatement;
		}

		override public NodeType NodeType
		{
			get
			{
				return NodeType.DeclarationStatement;
			}
		}

		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}

			if (_modifier == existing)
			{
				this.Modifier = (StatementModifier)newNode;
				return true;
			}

			if (_declaration == existing)
			{
				this.Declaration = (Declaration)newNode;
				return true;
			}

			if (_initializer == existing)
			{
				this.Initializer = (Expression)newNode;
				return true;
			}

			return false;
		}

		override public object Clone()
		{
			DeclarationStatement clone = FormatterServices.GetUninitializedObject(typeof(DeclarationStatement)) as DeclarationStatement;
			clone._lexicalInfo = _lexicalInfo;
			clone._documentation = _documentation;
			clone._entity = _entity;
			

			if (null != _modifier)
			{
				clone._modifier = _modifier.Clone() as StatementModifier;
				clone._modifier.InitializeParent(clone);
			}

			if (null != _declaration)
			{
				clone._declaration = _declaration.Clone() as Declaration;
				clone._declaration.InitializeParent(clone);
			}

			if (null != _initializer)
			{
				clone._initializer = _initializer.Clone() as Expression;
				clone._initializer.InitializeParent(clone);
			}
			
			return clone;
		}
			
		public Declaration Declaration
		{
			get
			{
				return _declaration;
			}
			

			set
			{
				if (_declaration != value)
				{
					_declaration = value;
					if (null != _declaration)
					{
						_declaration.InitializeParent(this);

					}
				}
			}
			

		}
		

		public Expression Initializer
		{
			get
			{
				return _initializer;
			}
			

			set
			{
				if (_initializer != value)
				{
					_initializer = value;
					if (null != _initializer)
					{
						_initializer.InitializeParent(this);

					}
				}
			}
			

		}
		

		private void InitializeFields()
		{

		}
	}
}
