﻿#region license
// boo - an extensible programming language for the CLI
// Copyright (C) 2004 Rodrigo Barreto de Oliveira
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
// 
// Contact Information
//
// mailto:rbo@acm.org
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by
// astgenerator.boo on 6/7/2004 23:57:01
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class FieldImpl : TypeMember
	{

		protected TypeReference _type;
		protected Expression _initializer;

		protected FieldImpl()
		{
			InitializeFields();
		}
		
		protected FieldImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		

		protected FieldImpl(TypeReference type, Expression initializer)
		{
			InitializeFields();
			Type = type;
			Initializer = initializer;
		}
			
		protected FieldImpl(LexicalInfo lexicalInfo, TypeReference type, Expression initializer) : base(lexicalInfo)
		{
			InitializeFields();
			Type = type;
			Initializer = initializer;
		}
			
		new public Field CloneNode()
		{
			return Clone() as Field;
		}

		override public NodeType NodeType
		{
			get
			{
				return NodeType.Field;
			}
		}

		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}

			if (_attributes != null)
			{
				Attribute item = existing as Attribute;
				if (null != item)
				{
					Attribute newItem = (Attribute)newNode;
					if (_attributes.Replace(item, newItem))
					{
						return true;
					}
				}
			}

			if (_type == existing)
			{
				this.Type = (TypeReference)newNode;
				return true;
			}

			if (_initializer == existing)
			{
				this.Initializer = (Expression)newNode;
				return true;
			}

			return false;
		}

		override public object Clone()
		{
			Field clone = FormatterServices.GetUninitializedObject(typeof(Field)) as Field;
			clone._lexicalInfo = _lexicalInfo;
			clone._documentation = _documentation;
			clone._entity = _entity;
			

			clone._modifiers = _modifiers;

			clone._name = _name;

			if (null != _attributes)
			{
				clone._attributes = _attributes.Clone() as AttributeCollection;
				clone._attributes.InitializeParent(clone);
			}

			if (null != _type)
			{
				clone._type = _type.Clone() as TypeReference;
				clone._type.InitializeParent(clone);
			}

			if (null != _initializer)
			{
				clone._initializer = _initializer.Clone() as Expression;
				clone._initializer.InitializeParent(clone);
			}
			
			return clone;
		}
			
		public TypeReference Type
		{
			get
			{
				return _type;
			}
			

			set
			{
				if (_type != value)
				{
					_type = value;
					if (null != _type)
					{
						_type.InitializeParent(this);

					}
				}
			}
			

		}
		

		public Expression Initializer
		{
			get
			{
				return _initializer;
			}
			

			set
			{
				if (_initializer != value)
				{
					_initializer = value;
					if (null != _initializer)
					{
						_initializer.InitializeParent(this);

					}
				}
			}
			

		}
		

		private void InitializeFields()
		{

		}
	}
}
