﻿#region license
// boo - an extensible programming language for the CLI
// Copyright (C) 2004 Rodrigo Barreto de Oliveira
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
// 
// Contact Information
//
// mailto:rbo@acm.org
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by
// astgenerator.boo on 6/7/2004 23:57:03
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class GeneratorExpressionImpl : Expression
	{

		protected Expression _expression;
		protected DeclarationCollection _declarations;
		protected Expression _iterator;
		protected StatementModifier _filter;

		protected GeneratorExpressionImpl()
		{
			InitializeFields();
		}
		
		protected GeneratorExpressionImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		

		protected GeneratorExpressionImpl(Expression expression, Expression iterator, StatementModifier filter)
		{
			InitializeFields();
			Expression = expression;
			Iterator = iterator;
			Filter = filter;
		}
			
		protected GeneratorExpressionImpl(LexicalInfo lexicalInfo, Expression expression, Expression iterator, StatementModifier filter) : base(lexicalInfo)
		{
			InitializeFields();
			Expression = expression;
			Iterator = iterator;
			Filter = filter;
		}
			
		new public GeneratorExpression CloneNode()
		{
			return Clone() as GeneratorExpression;
		}

		override public NodeType NodeType
		{
			get
			{
				return NodeType.GeneratorExpression;
			}
		}

		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}

			if (_expression == existing)
			{
				this.Expression = (Expression)newNode;
				return true;
			}

			if (_declarations != null)
			{
				Declaration item = existing as Declaration;
				if (null != item)
				{
					Declaration newItem = (Declaration)newNode;
					if (_declarations.Replace(item, newItem))
					{
						return true;
					}
				}
			}

			if (_iterator == existing)
			{
				this.Iterator = (Expression)newNode;
				return true;
			}

			if (_filter == existing)
			{
				this.Filter = (StatementModifier)newNode;
				return true;
			}

			return false;
		}

		override public object Clone()
		{
			GeneratorExpression clone = FormatterServices.GetUninitializedObject(typeof(GeneratorExpression)) as GeneratorExpression;
			clone._lexicalInfo = _lexicalInfo;
			clone._documentation = _documentation;
			clone._entity = _entity;
			

			clone._expressionType = _expressionType;
			

			if (null != _expression)
			{
				clone._expression = _expression.Clone() as Expression;
				clone._expression.InitializeParent(clone);
			}

			if (null != _declarations)
			{
				clone._declarations = _declarations.Clone() as DeclarationCollection;
				clone._declarations.InitializeParent(clone);
			}

			if (null != _iterator)
			{
				clone._iterator = _iterator.Clone() as Expression;
				clone._iterator.InitializeParent(clone);
			}

			if (null != _filter)
			{
				clone._filter = _filter.Clone() as StatementModifier;
				clone._filter.InitializeParent(clone);
			}
			
			return clone;
		}
			
		public Expression Expression
		{
			get
			{
				return _expression;
			}
			

			set
			{
				if (_expression != value)
				{
					_expression = value;
					if (null != _expression)
					{
						_expression.InitializeParent(this);

					}
				}
			}
			

		}
		

		public DeclarationCollection Declarations
		{
			get
			{
				return _declarations;
			}
			

			set
			{
				if (_declarations != value)
				{
					_declarations = value;
					if (null != _declarations)
					{
						_declarations.InitializeParent(this);

					}
				}
			}
			

		}
		

		public Expression Iterator
		{
			get
			{
				return _iterator;
			}
			

			set
			{
				if (_iterator != value)
				{
					_iterator = value;
					if (null != _iterator)
					{
						_iterator.InitializeParent(this);

					}
				}
			}
			

		}
		

		public StatementModifier Filter
		{
			get
			{
				return _filter;
			}
			

			set
			{
				if (_filter != value)
				{
					_filter = value;
					if (null != _filter)
					{
						_filter.InitializeParent(this);

					}
				}
			}
			

		}
		

		private void InitializeFields()
		{
			_declarations = new DeclarationCollection(this);

		}
	}
}
