﻿#region license
// boo - an extensible programming language for the CLI
// Copyright (C) 2004 Rodrigo Barreto de Oliveira
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
// 
// Contact Information
//
// mailto:rbo@acm.org
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by
// astgenerator.boo on 6/7/2004 23:57:02
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class GivenStatementImpl : Statement
	{

		protected Expression _expression;
		protected WhenClauseCollection _whenClauses;
		protected Block _otherwiseBlock;

		protected GivenStatementImpl()
		{
			InitializeFields();
		}
		
		protected GivenStatementImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		

		protected GivenStatementImpl(Expression expression, Block otherwiseBlock)
		{
			InitializeFields();
			Expression = expression;
			OtherwiseBlock = otherwiseBlock;
		}
			
		protected GivenStatementImpl(LexicalInfo lexicalInfo, Expression expression, Block otherwiseBlock) : base(lexicalInfo)
		{
			InitializeFields();
			Expression = expression;
			OtherwiseBlock = otherwiseBlock;
		}
			
		new public GivenStatement CloneNode()
		{
			return Clone() as GivenStatement;
		}

		override public NodeType NodeType
		{
			get
			{
				return NodeType.GivenStatement;
			}
		}

		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}

			if (_modifier == existing)
			{
				this.Modifier = (StatementModifier)newNode;
				return true;
			}

			if (_expression == existing)
			{
				this.Expression = (Expression)newNode;
				return true;
			}

			if (_whenClauses != null)
			{
				WhenClause item = existing as WhenClause;
				if (null != item)
				{
					WhenClause newItem = (WhenClause)newNode;
					if (_whenClauses.Replace(item, newItem))
					{
						return true;
					}
				}
			}

			if (_otherwiseBlock == existing)
			{
				this.OtherwiseBlock = (Block)newNode;
				return true;
			}

			return false;
		}

		override public object Clone()
		{
			GivenStatement clone = FormatterServices.GetUninitializedObject(typeof(GivenStatement)) as GivenStatement;
			clone._lexicalInfo = _lexicalInfo;
			clone._documentation = _documentation;
			clone._entity = _entity;
			

			if (null != _modifier)
			{
				clone._modifier = _modifier.Clone() as StatementModifier;
				clone._modifier.InitializeParent(clone);
			}

			if (null != _expression)
			{
				clone._expression = _expression.Clone() as Expression;
				clone._expression.InitializeParent(clone);
			}

			if (null != _whenClauses)
			{
				clone._whenClauses = _whenClauses.Clone() as WhenClauseCollection;
				clone._whenClauses.InitializeParent(clone);
			}

			if (null != _otherwiseBlock)
			{
				clone._otherwiseBlock = _otherwiseBlock.Clone() as Block;
				clone._otherwiseBlock.InitializeParent(clone);
			}
			
			return clone;
		}
			
		public Expression Expression
		{
			get
			{
				return _expression;
			}
			

			set
			{
				if (_expression != value)
				{
					_expression = value;
					if (null != _expression)
					{
						_expression.InitializeParent(this);

					}
				}
			}
			

		}
		

		public WhenClauseCollection WhenClauses
		{
			get
			{
				return _whenClauses;
			}
			

			set
			{
				if (_whenClauses != value)
				{
					_whenClauses = value;
					if (null != _whenClauses)
					{
						_whenClauses.InitializeParent(this);

					}
				}
			}
			

		}
		

		public Block OtherwiseBlock
		{
			get
			{
				return _otherwiseBlock;
			}
			

			set
			{
				if (_otherwiseBlock != value)
				{
					_otherwiseBlock = value;
					if (null != _otherwiseBlock)
					{
						_otherwiseBlock.InitializeParent(this);

					}
				}
			}
			

		}
		

		private void InitializeFields()
		{
			_whenClauses = new WhenClauseCollection(this);

		}
	}
}
