﻿#region license
// boo - an extensible programming language for the CLI
// Copyright (C) 2004 Rodrigo Barreto de Oliveira
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
// 
// Contact Information
//
// mailto:rbo@acm.org
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by
// astgenerator.boo on 6/7/2004 23:57:01
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class ImportImpl : Node
	{

		protected string _namespace;
		protected ReferenceExpression _assemblyReference;
		protected ReferenceExpression _alias;

		protected ImportImpl()
		{
			InitializeFields();
		}
		
		protected ImportImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		

		protected ImportImpl(string namespace_, ReferenceExpression assemblyReference, ReferenceExpression alias)
		{
			InitializeFields();
			Namespace = namespace_;
			AssemblyReference = assemblyReference;
			Alias = alias;
		}
			
		protected ImportImpl(LexicalInfo lexicalInfo, string namespace_, ReferenceExpression assemblyReference, ReferenceExpression alias) : base(lexicalInfo)
		{
			InitializeFields();
			Namespace = namespace_;
			AssemblyReference = assemblyReference;
			Alias = alias;
		}
			
		new public Import CloneNode()
		{
			return Clone() as Import;
		}

		override public NodeType NodeType
		{
			get
			{
				return NodeType.Import;
			}
		}

		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}

			if (_assemblyReference == existing)
			{
				this.AssemblyReference = (ReferenceExpression)newNode;
				return true;
			}

			if (_alias == existing)
			{
				this.Alias = (ReferenceExpression)newNode;
				return true;
			}

			return false;
		}

		override public object Clone()
		{
			Import clone = FormatterServices.GetUninitializedObject(typeof(Import)) as Import;
			clone._lexicalInfo = _lexicalInfo;
			clone._documentation = _documentation;
			clone._entity = _entity;
			

			clone._namespace = _namespace;

			if (null != _assemblyReference)
			{
				clone._assemblyReference = _assemblyReference.Clone() as ReferenceExpression;
				clone._assemblyReference.InitializeParent(clone);
			}

			if (null != _alias)
			{
				clone._alias = _alias.Clone() as ReferenceExpression;
				clone._alias.InitializeParent(clone);
			}
			
			return clone;
		}
			
		public string Namespace
		{
			get
			{
				return _namespace;
			}
			

			set
			{
				_namespace = value;
			}

		}
		

		public ReferenceExpression AssemblyReference
		{
			get
			{
				return _assemblyReference;
			}
			

			set
			{
				if (_assemblyReference != value)
				{
					_assemblyReference = value;
					if (null != _assemblyReference)
					{
						_assemblyReference.InitializeParent(this);

					}
				}
			}
			

		}
		

		public ReferenceExpression Alias
		{
			get
			{
				return _alias;
			}
			

			set
			{
				if (_alias != value)
				{
					_alias = value;
					if (null != _alias)
					{
						_alias.InitializeParent(this);

					}
				}
			}
			

		}
		

		private void InitializeFields()
		{

		}
	}
}
