﻿#region license
// boo - an extensible programming language for the CLI
// Copyright (C) 2004 Rodrigo Barreto de Oliveira
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
// 
// Contact Information
//
// mailto:rbo@acm.org
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by
// astgenerator.boo on 6/7/2004 23:57:03
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class SlicingExpressionImpl : Expression
	{

		protected Expression _target;
		protected Expression _begin;
		protected Expression _end;
		protected Expression _step;

		protected SlicingExpressionImpl()
		{
			InitializeFields();
		}
		
		protected SlicingExpressionImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		

		protected SlicingExpressionImpl(Expression target, Expression begin, Expression end, Expression step)
		{
			InitializeFields();
			Target = target;
			Begin = begin;
			End = end;
			Step = step;
		}
			
		protected SlicingExpressionImpl(LexicalInfo lexicalInfo, Expression target, Expression begin, Expression end, Expression step) : base(lexicalInfo)
		{
			InitializeFields();
			Target = target;
			Begin = begin;
			End = end;
			Step = step;
		}
			
		new public SlicingExpression CloneNode()
		{
			return Clone() as SlicingExpression;
		}

		override public NodeType NodeType
		{
			get
			{
				return NodeType.SlicingExpression;
			}
		}

		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}

			if (_target == existing)
			{
				this.Target = (Expression)newNode;
				return true;
			}

			if (_begin == existing)
			{
				this.Begin = (Expression)newNode;
				return true;
			}

			if (_end == existing)
			{
				this.End = (Expression)newNode;
				return true;
			}

			if (_step == existing)
			{
				this.Step = (Expression)newNode;
				return true;
			}

			return false;
		}

		override public object Clone()
		{
			SlicingExpression clone = FormatterServices.GetUninitializedObject(typeof(SlicingExpression)) as SlicingExpression;
			clone._lexicalInfo = _lexicalInfo;
			clone._documentation = _documentation;
			clone._entity = _entity;
			

			clone._expressionType = _expressionType;
			

			if (null != _target)
			{
				clone._target = _target.Clone() as Expression;
				clone._target.InitializeParent(clone);
			}

			if (null != _begin)
			{
				clone._begin = _begin.Clone() as Expression;
				clone._begin.InitializeParent(clone);
			}

			if (null != _end)
			{
				clone._end = _end.Clone() as Expression;
				clone._end.InitializeParent(clone);
			}

			if (null != _step)
			{
				clone._step = _step.Clone() as Expression;
				clone._step.InitializeParent(clone);
			}
			
			return clone;
		}
			
		public Expression Target
		{
			get
			{
				return _target;
			}
			

			set
			{
				if (_target != value)
				{
					_target = value;
					if (null != _target)
					{
						_target.InitializeParent(this);

					}
				}
			}
			

		}
		

		public Expression Begin
		{
			get
			{
				return _begin;
			}
			

			set
			{
				if (_begin != value)
				{
					_begin = value;
					if (null != _begin)
					{
						_begin.InitializeParent(this);

					}
				}
			}
			

		}
		

		public Expression End
		{
			get
			{
				return _end;
			}
			

			set
			{
				if (_end != value)
				{
					_end = value;
					if (null != _end)
					{
						_end.InitializeParent(this);

					}
				}
			}
			

		}
		

		public Expression Step
		{
			get
			{
				return _step;
			}
			

			set
			{
				if (_step != value)
				{
					_step = value;
					if (null != _step)
					{
						_step.InitializeParent(this);

					}
				}
			}
			

		}
		

		private void InitializeFields()
		{

		}
	}
}
