﻿#region license
// boo - an extensible programming language for the CLI
// Copyright (C) 2004 Rodrigo Barreto de Oliveira
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
// 
// Contact Information
//
// mailto:rbo@acm.org
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by
// astgenerator.boo on 6/7/2004 23:57:02
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class TryStatementImpl : Statement
	{

		protected Block _protectedBlock;
		protected ExceptionHandlerCollection _exceptionHandlers;
		protected Block _successBlock;
		protected Block _ensureBlock;

		protected TryStatementImpl()
		{
			InitializeFields();
		}
		
		protected TryStatementImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		

		protected TryStatementImpl(Block successBlock, Block ensureBlock)
		{
			InitializeFields();
			SuccessBlock = successBlock;
			EnsureBlock = ensureBlock;
		}
			
		protected TryStatementImpl(LexicalInfo lexicalInfo, Block successBlock, Block ensureBlock) : base(lexicalInfo)
		{
			InitializeFields();
			SuccessBlock = successBlock;
			EnsureBlock = ensureBlock;
		}
			
		new public TryStatement CloneNode()
		{
			return Clone() as TryStatement;
		}

		override public NodeType NodeType
		{
			get
			{
				return NodeType.TryStatement;
			}
		}

		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}

			if (_modifier == existing)
			{
				this.Modifier = (StatementModifier)newNode;
				return true;
			}

			if (_protectedBlock == existing)
			{
				this.ProtectedBlock = (Block)newNode;
				return true;
			}

			if (_exceptionHandlers != null)
			{
				ExceptionHandler item = existing as ExceptionHandler;
				if (null != item)
				{
					ExceptionHandler newItem = (ExceptionHandler)newNode;
					if (_exceptionHandlers.Replace(item, newItem))
					{
						return true;
					}
				}
			}

			if (_successBlock == existing)
			{
				this.SuccessBlock = (Block)newNode;
				return true;
			}

			if (_ensureBlock == existing)
			{
				this.EnsureBlock = (Block)newNode;
				return true;
			}

			return false;
		}

		override public object Clone()
		{
			TryStatement clone = FormatterServices.GetUninitializedObject(typeof(TryStatement)) as TryStatement;
			clone._lexicalInfo = _lexicalInfo;
			clone._documentation = _documentation;
			clone._entity = _entity;
			

			if (null != _modifier)
			{
				clone._modifier = _modifier.Clone() as StatementModifier;
				clone._modifier.InitializeParent(clone);
			}

			if (null != _protectedBlock)
			{
				clone._protectedBlock = _protectedBlock.Clone() as Block;
				clone._protectedBlock.InitializeParent(clone);
			}

			if (null != _exceptionHandlers)
			{
				clone._exceptionHandlers = _exceptionHandlers.Clone() as ExceptionHandlerCollection;
				clone._exceptionHandlers.InitializeParent(clone);
			}

			if (null != _successBlock)
			{
				clone._successBlock = _successBlock.Clone() as Block;
				clone._successBlock.InitializeParent(clone);
			}

			if (null != _ensureBlock)
			{
				clone._ensureBlock = _ensureBlock.Clone() as Block;
				clone._ensureBlock.InitializeParent(clone);
			}
			
			return clone;
		}
			
		public Block ProtectedBlock
		{
			get
			{
				return _protectedBlock;
			}
			

			set
			{
				if (_protectedBlock != value)
				{
					_protectedBlock = value;
					if (null != _protectedBlock)
					{
						_protectedBlock.InitializeParent(this);

					}
				}
			}
			

		}
		

		public ExceptionHandlerCollection ExceptionHandlers
		{
			get
			{
				return _exceptionHandlers;
			}
			

			set
			{
				if (_exceptionHandlers != value)
				{
					_exceptionHandlers = value;
					if (null != _exceptionHandlers)
					{
						_exceptionHandlers.InitializeParent(this);

					}
				}
			}
			

		}
		

		public Block SuccessBlock
		{
			get
			{
				return _successBlock;
			}
			

			set
			{
				if (_successBlock != value)
				{
					_successBlock = value;
					if (null != _successBlock)
					{
						_successBlock.InitializeParent(this);

					}
				}
			}
			

		}
		

		public Block EnsureBlock
		{
			get
			{
				return _ensureBlock;
			}
			

			set
			{
				if (_ensureBlock != value)
				{
					_ensureBlock = value;
					if (null != _ensureBlock)
					{
						_ensureBlock.InitializeParent(this);

					}
				}
			}
			

		}
		

		private void InitializeFields()
		{

			_protectedBlock = new Block();
			_protectedBlock.InitializeParent(this);
			
			_exceptionHandlers = new ExceptionHandlerCollection(this);

		}
	}
}
