﻿#region license
// boo - an extensible programming language for the CLI
// Copyright (C) 2004 Rodrigo Barreto de Oliveira
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
// 
// Contact Information
//
// mailto:rbo@acm.org
#endregion

namespace Boo.Lang.Compiler.Pipelines
{
	using System;
	using Boo.Lang.Compiler.Steps;
	
	public class Compile : Parse
	{
		public Compile()
		{			
			Add(new InitializeNameResolutionService());
			Add(new IntroduceGlobalNamespaces());
			Add(new TransformCallableDefinitions());
			Add(new BindTypeDefinitions());			
			Add(new BindNamespaces());
			Add(new BindBaseTypes());
			Add(new BindAndApplyAttributes());
			Add(new ExpandMacros());
			Add(new IntroduceModuleClasses());
			Add(new NormalizeTypeMembers());
			Add(new NormalizeStatementModifiers());
			
			Add(new BindTypeDefinitions());
			Add(new BindBaseTypes());
			
			Add(new BindTypeMembers());			
			Add(new ProcessMethodBodies());
			Add(new StricterErrorChecking());
			
			Add(new ProcessGenerators());
			Add(new CheckInterfaceImplementations());
			Add(new InjectCallableConversions());
			Add(new ImplementICallableOnCallableDefinitions());			
		}
	}
}
